
#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;

bool tbl[16][16];
char types[15];
pair<int,int> poss[15];
int ans, n, h, w;
bool eliminated[15];

bool attacks(int a,int b){
	switch(types[a]){
	case 'K':
		if(abs(poss[a].first -poss[b].first) <= 1 &&
			 abs(poss[a].second-poss[b].second) <= 1)
			return true;
		break;
	case 'Q':
		if(poss[a].first  == poss[b].first ||
			 poss[a].second == poss[b].second)
			return true;
		if(abs(poss[a].first  - poss[b].first) ==
			 abs(poss[a].second - poss[b].second))
			return true;
		break;
	case 'R' :
		if(poss[a].first  == poss[b].first ||
			 poss[a].second == poss[b].second)
			return true;
		break;
	case 'B' :
		if(abs(poss[a].first  - poss[b].first) ==
			 abs(poss[a].second - poss[b].second))
			return true;
		break;
	case 'N':
		if(poss[a].first  != poss[b].first &&
			 poss[a].second != poss[b].second &&
			 abs(poss[a].first -poss[b].first) +
			 abs(poss[a].second-poss[b].second) == 3)
			return true;
		break;
	}
	return false;
}

int dfs(int idx){
	if(idx == n) return 0;
	if(eliminated[idx]) return 1+dfs(idx+1);
	int ans = 1 + dfs(idx+1);
	vector<int> v;
	for(int t = idx+1; t<n;t++){
		if(tbl[idx][t] && !eliminated[t]){
			v.push_back(t);
			eliminated[t] = true;
		}
	}
	ans = min(ans, dfs(idx+1));
	for(int i=0;i<v.size();i++)
		eliminated[v[i]] = false;
	return ans;
}


int main(void){
	while(true){
		string dummy;
		cin >> dummy >> w >> h;
		if(!cin) break;
		n = 0;
		for(int i=0;i<h;i++)
			for(int j=0; j<w;j++){
				char c;
				cin >> c;
				if(c == 'E') continue;
				types[n] = c;
				poss[n] = make_pair(i,j);
				n++;
			}
		cin >> dummy;
		for(int i=0;i<n;i++)
			for(int j=0;j<n;j++)
				tbl[i][j] = false;
		for(int i=0;i<n;i++)
			for(int j=i+1;j<n;j++)
				if(attacks(i,j) || attacks(j,i))
					tbl[i][j] = tbl[i][j] = true;
		for(int i=0;i<n;i++)
			eliminated[i] = false;
		cout << "Minimum Number of Pieces to be removed: "<<dfs(0)<<endl;
	}
	return 0;
}

